"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.addChainToAngularJson = exports.setAllCustomWebpackChainingToAngularJson = exports.setCustomWebpackChainingToAngularJson = exports.setAllCustomWebpackBuilderToAngularJson = exports.setCustomWebpackBuilderToAngularJson = void 0;
/* const BUILDERS = { */
/* 	'build': '@angular-builders/custom-webpack:browser', */
/* 	'serve': '@angular-builders/custom-webpack:dev-server', */
/* 	'server': '@angular-builders/custom-webpack:server', */
/* 	'test': '@angular-builders/custom-webpack:karma' */
/* }; */
const BUILDERS = {
    'build': 'angular-custom-webpack-chaining:browser',
    'serve': 'angular-custom-webpack-chaining:dev-server',
    'server': 'angular-custom-webpack-chaining:server',
    'test': 'angular-custom-webpack-chaining:karma'
};
function setCustomWebpackBuilderToAngularJson(host, projectName, architect = BUILDERS['build'], builder = 'browser', webpackConfigPath = './extra-webpack.config.js') {
    if (host.exists('angular.json')) {
        const json = JSON.parse(host.read('angular.json').toString('utf-8'));
        json.projects[projectName].architect[architect].builder = builder;
        /* if (!json.projects[projectName].architect[architect].options.customWebpackConfig) { */
        /* 	json.projects[projectName].architect[architect].options['customWebpackConfig'] = { */
        /* 		'path': webpackConfigPath, */
        /* 	}; */
        /* } */
        host.overwrite('angular.json', JSON.stringify(json, null, 2));
    }
    return host;
}
exports.setCustomWebpackBuilderToAngularJson = setCustomWebpackBuilderToAngularJson;
function setAllCustomWebpackBuilderToAngularJson(host, projectName, webpackConfigPath = './extra-webpack.config.js') {
    if (host.exists('angular.json')) {
        const json = JSON.parse(host.read('angular.json').toString('utf-8'));
        for (const architect of Object.keys(json.projects[projectName].architect)) {
            if (architect in BUILDERS) {
                host = setCustomWebpackBuilderToAngularJson(host, projectName, architect, BUILDERS[architect], webpackConfigPath);
            }
        }
    }
    return host;
}
exports.setAllCustomWebpackBuilderToAngularJson = setAllCustomWebpackBuilderToAngularJson;
function setCustomWebpackChainingToAngularJson(host, projectName, architect = 'build') {
    if (host.exists('angular.json')) {
        const json = JSON.parse(host.read('angular.json').toString('utf-8'));
        if (!json.projects[projectName].architect[architect].options.customWebpackConfig) {
            json.projects[projectName].architect[architect].options['customWebpackConfig'] = {
                'chain': []
            };
        }
        host.overwrite('angular.json', JSON.stringify(json, null, 2));
    }
    return host;
}
exports.setCustomWebpackChainingToAngularJson = setCustomWebpackChainingToAngularJson;
function setAllCustomWebpackChainingToAngularJson(host, projectName) {
    if (host.exists('angular.json')) {
        const json = JSON.parse(host.read('angular.json').toString('utf-8'));
        for (const architect of Object.keys(json.projects[projectName].architect)) {
            if (architect in BUILDERS) {
                host = setCustomWebpackChainingToAngularJson(host, projectName, architect);
            }
        }
    }
    return host;
}
exports.setAllCustomWebpackChainingToAngularJson = setAllCustomWebpackChainingToAngularJson;
function addChainToAngularJson(host, projectName, webpackConfigPath, architect = 'build') {
    if (host.exists('angular.json')) {
        const json = JSON.parse(host.read('angular.json').toString('utf-8'));
        const options = json.projects[projectName].architect.options;
        if (!json.projects[projectName].architect[architect].options.customWebpackConfig) {
            json.projects[projectName].architect[architect].options['customWebpackConfig'] = {
                chain: []
            };
        }
        if (!~json.projects[projectName].architect[architect].options.customWebpackConfig.chain.indexOf(webpackConfigPath)) {
            json.projects[projectName].architect[architect].options.customWebpackConfig.chain.push(webpackConfigPath);
        }
        host.overwrite('angular.json', JSON.stringify(json, null, 2));
    }
    return host;
}
exports.addChainToAngularJson = addChainToAngularJson;
//# sourceMappingURL=angular-config.js.map